apiVersion: v1
kind: PersistentVolumeClaim
metadata: 
  name: mongodb-pvc
  namespace: default
  labels: 
    app: mongo-db
spec: 
  storageClassName: standard
  accessModes: 
    - ReadWriteOnce
  resources: 
    requests: 
      storage: 500Mi

---

apiVersion: v1
kind: Service
metadata:
  name: mongo-db
  namespace: default
  labels:
    app: mongo-db
spec:
  type: ClusterIP
  ports:
  - name: http
    port: 27017
    protocol: TCP
    targetPort: 27017
  selector:
    app: mongo-db

---

apiVersion: apps/v1
kind: Deployment
metadata: 
  name: mongo-db-deploy
  namespace: default
spec: 
  selector: 
    matchLabels: 
      app: mongo-db
  replicas: 1
  strategy: 
    type: RollingUpdate
    rollingUpdate: 
      maxSurge: 1
      maxUnavailable: 0
  minReadySeconds: 5
  template: 
    metadata: 
      labels: 
        app: mongo-db
    spec: 
      containers: 
      - name: mongo-db
        image: mongo
        ports: 
        - containerPort: 27017
          name: mongodb
        volumeMounts: 
          - name: mongodb-persistent-storage
            mountPath: /data/db
        resources:
          requests:
            memory: "256Mi"
            cpu: "250m"
          limits:
            memory: "512Mi"
            cpu: "500m"
      volumes: 
        - name: mongodb-persistent-storage
          persistentVolumeClaim: 
            claimName: mongodb-pvc

